package body Thread is

    procedure Initialize(S: out State) is 
    begin
        S := Ready;
    end Initialize;

    -- ---------------------------------------------------------------

    function Do_Ready(A: Action) return State is
    begin
        case A is
            when Start    => return Running;
            when Stop     => return Stopped;
            when others   => return None;
        end case;
    end Do_Ready;

    -- ---------------------------------------------------------------

    function Do_Running(A: Action) return State is
    begin
        case A is
            when Sleep   => return Sleeping;
            when Wait    => return Waiting;
            when Stop    => return Stopped;
            when others  => return None;
        end case;
    end Do_Running;

    -- ---------------------------------------------------------------

    function Do_Sleeping(A: Action) return State is
    begin
        case A is
            when Resume  => return Running;
            when others  => return None;
        end case;
    end Do_Sleeping;

    -- ---------------------------------------------------------------

    function Do_Waiting(A: Action) return State is
    begin
        case A is
            when Notify  => return Running;
            when others  => return None;
        end case;
    end Do_Waiting;

    -- ---------------------------------------------------------------

    procedure Do_Action(S: in out State; A: Action) is
    begin
        case S is
            when Ready    => S := Do_Ready(A);
            when Waiting  => S := Do_Waiting(A);
            when Running  => S := Do_Running(A);
            when Sleeping => S := Do_Sleeping(A);
            when Stopped  => S := None;
            when others   => S := None;
        end case;
    end Do_Action;

end Thread;